#include "GenAlg.h"
#include <stdlib.h>
#include <time.h>
#include <stdio.h>

GenAlg::GenAlg(OptScheduling* optScheduling):mOptScheduling(std::unique_ptr<OptScheduling>(optScheduling))
{

}

int GenAlg::random()
{
    srand((unsigned)time(NULL));
    return rand();
}

void GenAlg::init(int popsize, double MutRate, double CrossRate, int GenLenght, double LeftPoint, double RightPoint)
{
    mPopSize = popsize;
    mMutationRate = MutRate;
    mCrossoverRate = CrossRate;
    mChromoLength = GenLenght;
    mTotalFitness = 0;
    mGeneration = 0;

    mBestFitness = 0.0;
    mWorstFitness = 99999999;
    mAverageFitness = 0;
    mMaxPerturbation = 0.001;

    mLeftPoint = LeftPoint;
    mRightPoint = RightPoint;

    // ȺԳʼ  
    vecPop.clear();
    for (int i = 0; i < mPopSize; i++)
    {
        // Ĺ캯ѾӦֳʼΪ0  
        vecPop.push_back(Genome());

        // еĻʼΪڵ  
        for (int j = 0; j < mChromoLength; j++)
        {
            vecPop[i].vecGenome.push_back(random() * (mRightPoint - mLeftPoint) + mLeftPoint);
        }
    }
}

void GenAlg::mutate(vector<double>& chromo)
{
    // ѭԤͻ,Իͻ  
    for (int i = 0; i < chromo.size(); ++i)
    {
       // ͻĻ  
        if (random() < mMutationRate)
        {
            // ʹȨֵӻ߼һСֵ  
            chromo[i] += ((random() - 0.5) * mMaxPerturbation);

            // ұ߽  
            if (chromo[i] < mLeftPoint)
            {
                chromo[i] = mRightPoint;
            }
            else if (chromo[i] > mRightPoint)
            {
                chromo[i] = mLeftPoint;
            }
        }
    }
}

Genome GenAlg::chromoRoulette()
{
    // һ 0 ȺӦ֮ܺ.  mTotalFitness¼ȺӦԷܺ
    double slice = (random()) * mTotalFitness;

    // 򽫳תѡǸ.  
    Genome theChosenOne;

    // ۼӦԷĺ.  
    double fitnessSoFar = 0;

    // ȺÿһȾɫ塣  
    for (int i = 0; i < mPopSize; ++i)
    {
        //ۼӦԷ.  
        fitnessSoFar += vecPop[i].fitness;

        //ۼƷ,ѡʱĻ.  
        if (fitnessSoFar >= slice)
        {
            theChosenOne = vecPop[i];
            break;
        }
    }
    //תѡĸ  
    return theChosenOne;
}

void GenAlg::calculateBestWorstAvTot()
{

}

void GenAlg::reset()
{

}

void GenAlg::epoch(vector<Genome>& vecNewPop)
{

}

Genome GenAlg::bestFitness()
{
    Genome genome;
    return genome;
}

double GenAlg::averageFitness()
{
    return 0;
}

