#pragma once
#include "pandaAlgorithm.h"
#include "genome.h"

#include <vector>
#include <memory>

using namespace std;

class OptScheduling;
/**
   Ŵ㷨
*/
class  GenAlg
{
public:
    //캯  
    GenAlg(OptScheduling* optScheduling);

    //ʼ  
    void reset();

    //ʼ  
    void init(int popsize, double MutRate, double CrossRate, int GenLenght, double LeftPoint, double RightPoint);

    // mTotalFitness, mBestFitness, mWorstFitness, mAverageFitnessȱ  
    void calculateBestWorstAvTot();

    // ̶ѡ  
    Genome chromoRoulette();

    // 캯  
    void mutate(vector<double>& chromo);

    //⺯һ  
    void epoch(vector<Genome>& vecNewPop);

    // ȡӦȵĻ
    Genome bestFitness();

    // ȡƽӦ
    double averageFitness();

    // 
    int random();

private:
    // ÿһȾɫ  
    vector <Genome>    vecPop;

    // Ⱥ  
    int mPopSize;

    // ÿһȾɫĻĿ  
    int mChromoLength;

    // иӦӦֵܺ  
    double mTotalFitness;

    //и嵱ӦĸӦ  
    double mBestFitness;

    // иӦֵƽֵ  
    double mAverageFitness;

    // и嵱ӦĸӦ  
    double mWorstFitness;

    // Ӧĸm_vecPop  
    Genome mFittestGenome;

    // ͻĸ,һ0.050.3֮  
    double mMutationRate;

    // 򽻲ĸһΪ0.7  
    double mCrossoverRate;

    // ļ  
    int mGeneration;

    // 첽  
    double mMaxPerturbation;

    // ߽
    double mLeftPoint;

    // ұ߽
    double mRightPoint;

    // ŻȺ
    std::unique_ptr<OptScheduling> mOptScheduling;
};
